## musl 1.1.23

=== debian/changelog ===
musl (1.1.23-1) unstable; urgency=medium

  * New upstream release.
  * New supported architecture: riscv64
  * Revert "Point to experimental branch in Vcs-Git".
  * Update debian/copyright.
  * Bump Standards-Version to 4.4.0; no changes needed.

 -- Reiner Herrmann <reiner@reiner-h.de>  Wed, 17 Jul 2019 19:27:50 +0200

musl (1.1.22-1) experimental; urgency=medium

  * New upstream release.
  * Point to experimental branch in Vcs-Git.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 11 Apr 2019 18:41:58 +0200

=== debian/control ===
Source: musl
Section: libs
Priority: optional
Maintainer: Reiner Herrmann <reiner@reiner-h.de>
Build-Depends: debhelper-compat (= 12), dh-exec
Standards-Version: 4.4.0
Homepage: https://www.musl-libc.org/
Vcs-Git: https://salsa.debian.org/deki-guest/musl.git
Vcs-Browser: https://salsa.debian.org/deki-guest/musl
Rules-Requires-Root: no

Package: musl
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
Multi-Arch: same
Depends: ${misc:Depends}
Description: standard C library
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the shared objects

Package: musl-dev
Section: libdevel
Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
Multi-Arch: same
Provides: ${libc-dev:Provides}
Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
Recommends: ${linux-musl-dev:Recommends}
Description: standard C library development files
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the static linked libraries
 and the include files.

Package: musl-tools
Section: devel
Architecture: arm64 armel armhf i386 amd64 m68k mips mipsel mips64el s390x sh4 ppc64el riscv64
Depends: ${misc:Depends}, musl-dev (= ${binary:Version}), gcc
Replaces: musl (<< 1.1.15-1)
Breaks: musl (<< 1.1.15-1)
Description: standard C library tools
 musl is lightweight, fast, simple, free and strives
 to be correct in the sense of standards-conformance
 and safety.
 .
 This package contains the gcc spec file and the
 musl-gcc wrapper script to make easy-to-deploy static
 and minimal dynamically linked programs.

## musl 1.1.24

=== Makefile ===
#
# Makefile for musl (requires GNU make)
#
# This is how simple every makefile should be...
# No, I take that back - actually most should be less than half this size.
#
# Use config.mak to override any of the following variables.
# Do not make changes here.
#

srcdir = .
exec_prefix = /usr/local
bindir = $(exec_prefix)/bin

prefix = /usr/local/musl
includedir = $(prefix)/include
libdir = $(prefix)/lib
syslibdir = /lib

SRC_DIRS = $(addprefix $(srcdir)/,src/* crt ldso)
BASE_GLOBS = $(addsuffix /*.c,$(SRC_DIRS))
ARCH_GLOBS = $(addsuffix /$(ARCH)/*.[csS],$(SRC_DIRS))
BASE_SRCS = $(sort $(wildcard $(BASE_GLOBS)))
ARCH_SRCS = $(sort $(wildcard $(ARCH_GLOBS)))
BASE_OBJS = $(patsubst $(srcdir)/%,%.o,$(basename $(BASE_SRCS)))
ARCH_OBJS = $(patsubst $(srcdir)/%,%.o,$(basename $(ARCH_SRCS)))
REPLACED_OBJS = $(sort $(subst /$(ARCH)/,/,$(ARCH_OBJS)))
ALL_OBJS = $(addprefix obj/, $(filter-out $(REPLACED_OBJS), $(sort $(BASE_OBJS) $(ARCH_OBJS))))

LIBC_OBJS = $(filter obj/src/%,$(ALL_OBJS))
LDSO_OBJS = $(filter obj/ldso/%,$(ALL_OBJS:%.o=%.lo))
CRT_OBJS = $(filter obj/crt/%,$(ALL_OBJS))

AOBJS = $(LIBC_OBJS)
LOBJS = $(LIBC_OBJS:.o=.lo)
GENH = obj/include/bits/alltypes.h obj/include/bits/syscall.h
GENH_INT = obj/src/internal/version.h
IMPH = $(addprefix $(srcdir)/, src/internal/stdio_impl.h src/internal/pthread_impl.h src/internal/locale_impl.h src/internal/libc.h)

LDFLAGS =
LDFLAGS_AUTO =
LIBCC = -lgcc
CPPFLAGS =
CFLAGS =
CFLAGS_AUTO = -Os -pipe
CFLAGS_C99FSE = -std=c99 -ffreestanding -nostdinc 

CFLAGS_ALL = $(CFLAGS_C99FSE)
CFLAGS_ALL += -D_XOPEN_SOURCE=700 -I$(srcdir)/arch/$(ARCH) -I$(srcdir)/arch/generic -Iobj/src/internal -I$(srcdir)/src/include -I$(srcdir)/src/internal -Iobj/include -I$(srcdir)/include
CFLAGS_ALL += $(CPPFLAGS) $(CFLAGS_AUTO) $(CFLAGS)

LDFLAGS_ALL = $(LDFLAGS_AUTO) $(LDFLAGS)

AR      = $(CROSS_COMPILE)ar
RANLIB  = $(CROSS_COMPILE)ranlib
INSTALL = $(srcdir)/tools/install.sh

ARCH_INCLUDES = $(wildcard $(srcdir)/arch/$(ARCH)/bits/*.h)
GENERIC_INCLUDES = $(wildcard $(srcdir)/arch/generic/bits/*.h)
INCLUDES = $(wildcard $(srcdir)/include/*.h $(srcdir)/include/*/*.h)
ALL_INCLUDES = $(sort $(INCLUDES:$(srcdir)/%=%) $(GENH:obj/%=%) $(ARCH_INCLUDES:$(srcdir)/arch/$(ARCH)/%=include/%) $(GENERIC_INCLUDES:$(srcdir)/arch/generic/%=include/%))

EMPTY_LIB_NAMES = m rt pthread crypt util xnet resolv dl
EMPTY_LIBS = $(EMPTY_LIB_NAMES:%=lib/lib%.a)
CRT_LIBS = $(addprefix lib/,$(notdir $(CRT_OBJS)))
STATIC_LIBS = lib/libc.a
SHARED_LIBS = lib/libc.so
TOOL_LIBS = lib/musl-gcc.specs
ALL_LIBS = $(CRT_LIBS) $(STATIC_LIBS) $(SHARED_LIBS) $(EMPTY_LIBS) $(TOOL_LIBS)
ALL_TOOLS = obj/musl-gcc

WRAPCC_GCC = gcc
WRAPCC_CLANG = clang

LDSO_PATHNAME = $(syslibdir)/ld-musl-$(ARCH)$(SUBARCH).so.1

-include config.mak

ifeq ($(ARCH),)

all:
	@echo "Please set ARCH in config.mak before running make."
	@exit 1

else

all: $(ALL_LIBS) $(ALL_TOOLS)

OBJ_DIRS = $(sort $(patsubst %/,%,$(dir $(ALL_LIBS) $(ALL_TOOLS) $(ALL_OBJS) $(GENH) $(GENH_INT))) obj/include)

$(ALL_LIBS) $(ALL_TOOLS) $(ALL_OBJS) $(ALL_OBJS:%.o=%.lo) $(GENH) $(GENH_INT): | $(OBJ_DIRS)

$(OBJ_DIRS):
	mkdir -p $@

obj/include/bits/alltypes.h: $(srcdir)/arch/$(ARCH)/bits/alltypes.h.in $(srcdir)/include/alltypes.h.in $(srcdir)/tools/mkalltypes.sed
	sed -f $(srcdir)/tools/mkalltypes.sed $(srcdir)/arch/$(ARCH)/bits/alltypes.h.in $(srcdir)/include/alltypes.h.in > $@

obj/include/bits/syscall.h: $(srcdir)/arch/$(ARCH)/bits/syscall.h.in
	cp $< $@
	sed -n -e s/__NR_/SYS_/p < $< >> $@

obj/src/internal/version.h: $(wildcard $(srcdir)/VERSION $(srcdir)/.git)
	printf '#define VERSION "%s"\n' "$$(cd $(srcdir); sh tools/version.sh)" > $@

obj/src/internal/version.o obj/src/internal/version.lo: obj/src/internal/version.h

obj/crt/rcrt1.o obj/ldso/dlstart.lo obj/ldso/dynlink.lo: $(srcdir)/src/internal/dynlink.h $(srcdir)/arch/$(ARCH)/reloc.h

obj/crt/crt1.o obj/crt/scrt1.o obj/crt/rcrt1.o obj/ldso/dlstart.lo: $(srcdir)/arch/$(ARCH)/crt_arch.h

obj/crt/rcrt1.o: $(srcdir)/ldso/dlstart.c

obj/crt/Scrt1.o obj/crt/rcrt1.o: CFLAGS_ALL += -fPIC

OPTIMIZE_SRCS = $(wildcard $(OPTIMIZE_GLOBS:%=$(srcdir)/src/%))
$(OPTIMIZE_SRCS:$(srcdir)/%.c=obj/%.o) $(OPTIMIZE_SRCS:$(srcdir)/%.c=obj/%.lo): CFLAGS += -O3

MEMOPS_OBJS = $(filter %/memcpy.o %/memmove.o %/memcmp.o %/memset.o, $(LIBC_OBJS))
$(MEMOPS_OBJS) $(MEMOPS_OBJS:%.o=%.lo): CFLAGS_ALL += $(CFLAGS_MEMOPS)

NOSSP_OBJS = $(CRT_OBJS) $(LDSO_OBJS) $(filter \
	%/__libc_start_main.o %/__init_tls.o %/__stack_chk_fail.o \
	%/__set_thread_area.o %/memset.o %/memcpy.o \
	, $(LIBC_OBJS))
$(NOSSP_OBJS) $(NOSSP_OBJS:%.o=%.lo): CFLAGS_ALL += $(CFLAGS_NOSSP)

$(CRT_OBJS): CFLAGS_ALL += -DCRT

$(LOBJS) $(LDSO_OBJS): CFLAGS_ALL += -fPIC

CC_CMD = $(CC) $(CFLAGS_ALL) -c -o $@ $<

# Choose invocation of assembler to be used
ifeq ($(ADD_CFI),yes)
	AS_CMD = LC_ALL=C awk -f $(srcdir)/tools/add-cfi.common.awk -f $(srcdir)/tools/add-cfi.$(ARCH).awk $< | $(CC) $(CFLAGS_ALL) -x assembler -c -o $@ -
else
	AS_CMD = $(CC_CMD)
endif

obj/%.o: $(srcdir)/%.s
	$(AS_CMD)

obj/%.o: $(srcdir)/%.S
	$(CC_CMD)

obj/%.o: $(srcdir)/%.c $(GENH) $(IMPH)
	$(CC_CMD)

obj/%.lo: $(srcdir)/%.s
	$(AS_CMD)

obj/%.lo: $(srcdir)/%.S
	$(CC_CMD)

obj/%.lo: $(srcdir)/%.c $(GENH) $(IMPH)
	$(CC_CMD)

lib/libc.so: $(LOBJS) $(LDSO_OBJS)
	$(CC) $(CFLAGS_ALL) $(LDFLAGS_ALL) -nostdlib -shared \
	-Wl,-e,_dlstart -o $@ $(LOBJS) $(LDSO_OBJS) $(LIBCC)

lib/libc.a: $(AOBJS)
	rm -f $@
	$(AR) rc $@ $(AOBJS)
	$(RANLIB) $@

$(EMPTY_LIBS):
	rm -f $@
	$(AR) rc $@

lib/%.o: obj/crt/$(ARCH)/%.o
	cp $< $@

lib/%.o: obj/crt/%.o
	cp $< $@

lib/musl-gcc.specs: $(srcdir)/tools/musl-gcc.specs.sh config.mak
	sh $< "$(includedir)" "$(libdir)" "$(LDSO_PATHNAME)" > $@

obj/musl-gcc: config.mak
	printf '#!/bin/sh\nexec "$${REALGCC:-$(WRAPCC_GCC)}" "$$@" -specs "%s/musl-gcc.specs"\n' "$(libdir)" > $@
	chmod +x $@

obj/%-clang: $(srcdir)/tools/%-clang.in config.mak
	sed -e 's!@CC@!$(WRAPCC_CLANG)!g' -e 's!@PREFIX@!$(prefix)!g' -e 's!@INCDIR@!$(includedir)!g' -e 's!@LIBDIR@!$(libdir)!g' -e 's!@LDSO@!$(LDSO_PATHNAME)!g' $< > $@
	chmod +x $@

$(DESTDIR)$(bindir)/%: obj/%
	$(INSTALL) -D $< $@

$(DESTDIR)$(libdir)/%.so: lib/%.so
	$(INSTALL) -D -m 755 $< $@

$(DESTDIR)$(libdir)/%: lib/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: $(srcdir)/arch/$(ARCH)/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: $(srcdir)/arch/generic/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/bits/%: obj/include/bits/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(includedir)/%: $(srcdir)/include/%
	$(INSTALL) -D -m 644 $< $@

$(DESTDIR)$(LDSO_PATHNAME): $(DESTDIR)$(libdir)/libc.so
	$(INSTALL) -D -l $(libdir)/libc.so $@ || true

install-libs: $(ALL_LIBS:lib/%=$(DESTDIR)$(libdir)/%) $(if $(SHARED_LIBS),$(DESTDIR)$(LDSO_PATHNAME),)

install-headers: $(ALL_INCLUDES:include/%=$(DESTDIR)$(includedir)/%)

install-tools: $(ALL_TOOLS:obj/%=$(DESTDIR)$(bindir)/%)

install: install-libs install-headers install-tools

musl-git-%.tar.gz: .git
	 git --git-dir=$(srcdir)/.git archive --format=tar.gz --prefix=$(patsubst %.tar.gz,%,$@)/ -o $@ $(patsubst musl-git-%.tar.gz,%,$@)

musl-%.tar.gz: .git
	 git --git-dir=$(srcdir)/.git archive --format=tar.gz --prefix=$(patsubst %.tar.gz,%,$@)/ -o $@ v$(patsubst musl-%.tar.gz,%,$@)

endif

clean:
	rm -rf obj lib

distclean: clean
	rm -f config.mak

.PHONY: all clean install install-libs install-headers install-tools

=== debian/changelog ===
musl (1.1.24-1) unstable; urgency=medium

  * New upstream release.
    - drop cherry-picked patch
  * Bump Standards-Version to 4.4.1.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 14 Oct 2019 00:56:01 +0200

musl (1.1.23-2) unstable; urgency=high

  * Cherry-pick patch to fix x87 stack imbalance in corner cases of
    i386 math asm (CVE-2019-14697).

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 06 Aug 2019 19:56:45 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
 Build-Depends: debhelper-compat (= 12), dh-exec
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://www.musl-libc.org/
 Vcs-Git: https://salsa.debian.org/deki-guest/musl.git
 Vcs-Browser: https://salsa.debian.org/deki-guest/musl

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Calculating musl based architecture
MUSL_ARCH=$(DEB_HOST_GNU_CPU)
MUSL_TRIPLE=$(DEB_HOST_GNU_CPU)-linux-musl

ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
  MUSL_ARCH=arm
  MUSL_TRIPLE=arm-linux-musleabi
endif

ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
  MUSL_ARCH=armhf
  MUSL_TRIPLE=arm-linux-musleabihf
endif

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  MUSL_ARCH=i386
  MUSL_TRIPLE=i386-linux-musl
endif

ifneq (,$(findstring ppc64el,$(DEB_HOST_ARCH)))
  export DEB_CFLAGS_MAINT_APPEND += -mlong-double-64
endif

export MUSL_ARCH
export MUSL_TRIPLE

# Cross build support
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CC ?= cc
else
  CC=$(DEB_HOST_GNU_TYPE)-gcc
  CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
  export CROSS_COMPILE
endif
export CC

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Substitue control file variables debending on the debian libc type
# If musl is the native libc, we can provide libc and depend on linux-libc-dev
ifneq (,$(findstring musl-linux-,$(DEB_HOST_ARCH)))
  GENCTRL_OPTIONS = -Vlibc-dev:Provides=libc-dev -Vlinux-libc-dev:Depends=linux-libc-dev
else
  GENCTRL_OPTIONS = -Vlinux-musl-dev:Recommends=linux-musl-dev
endif

%:
	dh $@

debian/scripts/$(MUSL_TRIPLE).path: debian/scripts/config.path.in
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' $< > $@
	cp debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-$(MUSL_ARCH).path

override_dh_auto_configure: debian/scripts/$(MUSL_TRIPLE).path
	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE) --enable-gcc-wrapper --enable-debug

override_dh_fixperms:
	dh_fixperms --exclude libc.so

override_dh_gencontrol:
	dh_gencontrol -- $(GENCTRL_OPTIONS)

override_dh_clean:
	rm -f debian/musl-dev.postinst debian/musl-dev.postrm
	dh_clean

override_dh_installdeb:
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' \
		debian/musl-dev.postinst.in > debian/musl-dev.postinst
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' \
		debian/musl-dev.postrm.in > debian/musl-dev.postrm
	dh_installdeb

override_dh_installchangelogs:
	dh_installchangelogs WHATSNEW

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
 https://www.musl-libc.org/releases/musl-([\d\.]+)\.tar\.gz

## musl 1.2.0

=== debian/changelog ===
musl (1.2.0-1) unstable; urgency=medium

  * New upstream release.
    - 64-bit time_t on all archs
  * Update upstream homepage.
  * Bump Standards-Version to 4.5.0.
  * Bump debhelper compat level to 13.
  * Update lintian-overrides with changed tag name.
  * Update Vcs-* URLs.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 03 Jul 2020 20:38:19 +0200

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
-Build-Depends: debhelper-compat (= 12), dh-exec
-Standards-Version: 4.4.1
-Homepage: https://www.musl-libc.org/
-Vcs-Git: https://salsa.debian.org/deki-guest/musl.git
-Vcs-Browser: https://salsa.debian.org/deki-guest/musl
+Build-Depends: debhelper-compat (= 13), dh-exec
+Standards-Version: 4.5.0
+Homepage: https://musl.libc.org/
+Vcs-Git: https://salsa.debian.org/reiner/musl.git
+Vcs-Browser: https://salsa.debian.org/reiner/musl
 Rules-Requires-Root: no
 
 Package: musl

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
 https://musl.libc.org/releases/musl-@ANY_VERSION@@ARCHIVE_EXT@

## musl 1.2.1

=== debian/changelog ===
musl (1.2.1-1) unstable; urgency=medium

  * New upstream release.
    - new malloc implementation (mallocng)
  * Update copyrights, bump copyright years and reorder sections.

 -- Reiner Herrmann <reiner@reiner-h.de>  Tue, 04 Aug 2020 20:05:24 +0200

## musl 1.2.2

=== debian/changelog ===
musl (1.2.2-4) unstable; urgency=medium

  * Import musl-fts. (Closes: #989746)
    - musl-dev provides musl-fts
    - document copyright
    - test compilation in autopkgtest
  * Revert "Point to experimental branch in Vcs-Git".
  * Bump Standards-Version to 4.6.0.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 21 Aug 2021 12:49:23 +0200

musl (1.2.2-3) experimental; urgency=medium

  * musl-dev on musl-any-any:
    - drop gcc dependency, which does not exist while bootstrapping
    - don't install musl-gcc wrapper, which is not useful on this arch

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 30 Apr 2021 00:26:14 +0200

musl (1.2.2-2) experimental; urgency=medium

  [ Helmut Grohne ]
  * Remove crypt functionality and drop crypt.h header. (Closes: #947193)

  [ Josh Triplett ]
  * Provide cross-compilation versions of musl-gcc. (Closes: #873364)

  [ Reiner Herrmann ]
  * Add Breaks and Replaces to musl-dev, as it has taken over specs file.
  * Replace override_dh_clean with d/clean.
  * Drop usage of dh-exec.
    Thanks to Nicolas Boulenguez for initial idea, Niels Thykier for hint
    about debhelper's built-in substitution. (Closes: #982782)
  * wrap-and-sort
  * Point to experimental branch in Vcs-Git.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 29 Apr 2021 19:26:09 +0200

musl (1.2.2-1) unstable; urgency=medium

  * New upstream release.
    - fix wcsnrtombs destination buffer overflow (CVE-2020-28928)
      (Closes: #975365)
  * Fix MUSL_ARCH/MUSL_TRIPLE on sh4 (-> sh). (Closes: #977130)
  * Update copyrights.
  * Update watch file to version 4.
  * Bump Standards-Version to 4.5.1.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 15 Jan 2021 19:03:01 +0100

=== debian/rules ===
#!/usr/bin/make -f
export DH_OPTIONS

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH_CPU ?= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

# Handle x86_64 -> x86-64
HOST_GNU_TYPE_PKG=$(subst _,-,$(DEB_HOST_GNU_TYPE))

# Calculating musl based architecture
MUSL_ARCH=$(DEB_HOST_GNU_CPU)
MUSL_TRIPLE=$(DEB_HOST_GNU_CPU)-linux-musl

ifneq (,$(findstring armel,$(DEB_HOST_ARCH)))
  MUSL_ARCH=arm
  MUSL_TRIPLE=arm-linux-musleabi
endif

ifneq (,$(findstring armhf,$(DEB_HOST_ARCH)))
  MUSL_ARCH=armhf
  MUSL_TRIPLE=arm-linux-musleabihf
endif

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  MUSL_ARCH=i386
  MUSL_TRIPLE=i386-linux-musl
endif

ifeq ($(DEB_HOST_ARCH_CPU),sh4)
  MUSL_ARCH=sh
  MUSL_TRIPLE=sh-linux-musl
endif

ifneq (,$(findstring ppc64el,$(DEB_HOST_ARCH)))
  export DEB_CFLAGS_MAINT_APPEND += -mlong-double-64
endif

export MUSL_ARCH
export MUSL_TRIPLE

CC=$(DEB_HOST_GNU_TYPE)-gcc
CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
export CROSS_COMPILE

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Substitute control file variables depending on the debian libc type
# If musl is the native libc, we can provide libc and depend on linux-libc-dev
ifneq (,$(filter musl-%,$(DEB_HOST_ARCH)))
  GENCTRL_OPTIONS = -Vlibc-dev:Provides=libc-dev -Vlinux-libc-dev:Depends=linux-libc-dev
  GCC_WRAPPER = no
else
  GENCTRL_OPTIONS = -Vlinux-musl-dev:Recommends=linux-musl-dev -Vgcc:Depends=gcc-$(HOST_GNU_TYPE_PKG)
  GCC_WRAPPER = yes
endif

%:
	dh $@

debian/scripts/$(MUSL_TRIPLE).path: debian/scripts/config.path.in
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' $< > $@
	cp debian/scripts/$(MUSL_TRIPLE).path debian/scripts/ld-musl-$(MUSL_ARCH).path

copy_fts:
	mkdir -p src/fts
	cp debian/musl-fts/fts.c debian/musl-fts/config.h src/fts/
	cp debian/musl-fts/fts.h include/

override_dh_auto_configure: debian/scripts/$(MUSL_TRIPLE).path copy_fts
	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE) --enable-gcc-wrapper=$(GCC_WRAPPER) --enable-debug

execute_after_dh_auto_install:
	rm debian/tmp/usr/lib/$(MUSL_TRIPLE)/libcrypt.a

execute_after_dh_install:
ifeq ($(GCC_WRAPPER),yes)
	mkdir -p  debian/musl-dev/usr/bin
	mv debian/tmp/usr/bin/musl-gcc debian/musl-dev/usr/bin/$(MUSL_TRIPLE)-gcc
	mv debian/tmp/usr/lib/$(MUSL_TRIPLE)/musl-gcc.specs debian/musl-dev/usr/lib/$(MUSL_TRIPLE)/musl-gcc.specs
endif

override_dh_fixperms:
	dh_fixperms --exclude libc.so

override_dh_gencontrol:
	dh_gencontrol -- $(GENCTRL_OPTIONS)

override_dh_installdeb:
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' \
		debian/musl-dev.postinst.in > debian/musl-dev.postinst
	sed 's/@MUSL_TRIPLE@/$(MUSL_TRIPLE)/g' \
		debian/musl-dev.postrm.in > debian/musl-dev.postrm
	dh_installdeb

override_dh_installchangelogs:
	dh_installchangelogs WHATSNEW

=== debian/tests/control ===
Tests: build
Depends: binutils, build-essential, musl-tools

## musl 1.2.3

=== debian/changelog ===
musl (1.2.3-1) unstable; urgency=medium

  * New upstream release.
  * Add lintian override for 'no-code-sections' as these libraries are
    intentionally empty.

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 07 Apr 2022 22:48:37 +0200

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
 https://musl.libc.org/releases/musl-@ANY_VERSION@@ARCHIVE_EXT@

## musl 1.2.4

=== debian/changelog ===
musl (1.2.4-1) unstable; urgency=medium

  [ Reiner Herrmann ]
  * New upstream release.
  * Set option to disable building with LTO, as it is not supported.
    (Closes: #1015552)
  * Stop recommending non-existing linux-musl-dev. (Closes: #1041559)
  * Apply patch from Harald Hoyer to allow linking with static-pie.
    (Closes: #996326)
  * Add autopkgtest for static-pie linking.
  * Update lintian overrides to new format.
  * Bump Standards-Version to 4.6.2.

  [ Helmut Grohne ]
  * Restore crypt functionality in libc.{a,so} for ABI compatibility.
    (Closes: #1022027)

 -- Reiner Herrmann <reiner@reiner-h.de>  Thu, 09 Nov 2023 23:26:24 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,21 @@
 Section: libs
 Priority: optional
 Maintainer: Reiner Herrmann <reiner@reiner-h.de>
-Build-Depends: debhelper-compat (= 13), dh-exec
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 13),
+               gcc-aarch64-linux-gnu [arm64],
+               gcc-arm-linux-gnueabi [armel],
+               gcc-arm-linux-gnueabihf [armhf],
+               gcc-i686-linux-gnu [i386],
+               gcc-m68k-linux-gnu [m68k],
+               gcc-mips-linux-gnu [mips],
+               gcc-mips64el-linux-gnuabi64 [mips64el],
+               gcc-mipsel-linux-gnu [mipsel],
+               gcc-powerpc64le-linux-gnu [ppc64el],
+               gcc-riscv64-linux-gnu [riscv64],
+               gcc-s390x-linux-gnu [s390x],
+               gcc-sh4-linux-gnu [sh4],
+               gcc-x86-64-linux-gnu [amd64]
+Standards-Version: 4.6.2
 Homepage: https://musl.libc.org/
 Vcs-Git: https://salsa.debian.org/reiner/musl.git
 Vcs-Browser: https://salsa.debian.org/reiner/musl
@@ -24,9 +37,13 @@
 Section: libdevel
 Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
 Multi-Arch: same
-Provides: ${libc-dev:Provides}
-Depends: ${misc:Depends}, musl (= ${binary:Version}), ${linux-libc-dev:Depends}
-Recommends: ${linux-musl-dev:Recommends}
+Provides: ${libc-dev:Provides}, musl-fts
+Depends: musl (= ${binary:Version}),
+         ${gcc:Depends},
+         ${linux-libc-dev:Depends},
+         ${misc:Depends}
+Replaces: musl-tools (<< 1.2.2-2)
+Breaks: musl-tools (<< 1.2.2-2)
 Description: standard C library development files
  musl is lightweight, fast, simple, free and strives
  to be correct in the sense of standards-conformance
@@ -34,11 +51,15 @@
  .
  This package contains the static linked libraries
  and the include files.
+ .
+ This package also contains the specs file and gcc
+ wrapper script for cross-compilation. For the native
+ musl-gcc script, install the musl-tools package.
 
 Package: musl-tools
 Section: devel
-Architecture: arm64 armel armhf i386 amd64 m68k mips mipsel mips64el s390x sh4 ppc64el riscv64
-Depends: ${misc:Depends}, musl-dev (= ${binary:Version}), gcc
+Architecture: amd64 arm64 armel armhf i386 m68k mips mips64el mipsel ppc64el riscv64 s390x sh4
+Depends: musl-dev (= ${binary:Version}), ${misc:Depends}
 Replaces: musl (<< 1.1.15-1)
 Breaks: musl (<< 1.1.15-1)
 Description: standard C library tools
@@ -46,6 +67,6 @@
  to be correct in the sense of standards-conformance
  and safety.
  .
- This package contains the gcc spec file and the
- musl-gcc wrapper script to make easy-to-deploy static
+ This package contains the musl-gcc wrapper script for
+ the native architecture, to make easy-to-deploy static
  and minimal dynamically linked programs.

## musl 1.2.5

=== debian/changelog ===
musl (1.2.5-3) unstable; urgency=medium

  * Provide renameat2 syscall wrapper. (Closes: #1105007)
  * Bump copyright year.
  * Bump Standards-Version to 4.7.2.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 17 May 2025 13:21:34 +0200

musl (1.2.5-2) unstable; urgency=medium

  * Import upstream fix for out-of-bounds write vulnerability. (CVE-2025-26519)
    (Closes: #1098238)
  * Bump Standards-Version to 4.7.1.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 22 Feb 2025 12:21:36 +0100

musl (1.2.5-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Install ld-musl-*so* and libc.so into /usr (DEP17 M2). (Closes: #1073676)

 -- Chris Hofstaedtler <zeha@debian.org>  Tue, 13 Aug 2024 20:37:19 +0200

musl (1.2.5-1) unstable; urgency=medium

  * New upstream release.
  * New supported architecture: loong64.
  * Fix watch file.

 -- Reiner Herrmann <reiner@reiner-h.de>  Mon, 25 Mar 2024 20:14:54 +0100

musl (1.2.4-2) unstable; urgency=medium

  * Fix typo in autopkgtest.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 10 Nov 2023 20:30:40 +0100

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
                gcc-arm-linux-gnueabi [armel],
                gcc-arm-linux-gnueabihf [armhf],
                gcc-i686-linux-gnu [i386],
+               gcc-loongarch64-linux-gnu [loong64],
                gcc-m68k-linux-gnu [m68k],
                gcc-mips-linux-gnu [mips],
                gcc-mips64el-linux-gnuabi64 [mips64el],
@@ -16,14 +17,14 @@
                gcc-s390x-linux-gnu [s390x],
                gcc-sh4-linux-gnu [sh4],
                gcc-x86-64-linux-gnu [amd64]
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://musl.libc.org/
 Vcs-Git: https://salsa.debian.org/reiner/musl.git
 Vcs-Browser: https://salsa.debian.org/reiner/musl
 Rules-Requires-Root: no
 
 Package: musl
-Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
+Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 loong64 musl-linux-loong64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
 Multi-Arch: same
 Depends: ${misc:Depends}
 Description: standard C library
@@ -35,7 +36,7 @@
 
 Package: musl-dev
 Section: libdevel
-Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
+Architecture: arm64 musl-linux-arm64 armel armhf musl-linux-armhf i386 musl-linux-i386 amd64 musl-linux-amd64 loong64 musl-linux-loong64 m68k musl-linux-m68k mips musl-linux-mips mipsel musl-linux-mipsel mips64el musl-linux-mips64el s390x musl-linux-s390x sh4 musl-linux-sh4 ppc64el musl-linux-ppc64el riscv64 musl-linux-riscv64
 Multi-Arch: same
 Provides: ${libc-dev:Provides}, musl-fts
 Depends: musl (= ${binary:Version}),
@@ -58,7 +59,7 @@
 
 Package: musl-tools
 Section: devel
-Architecture: amd64 arm64 armel armhf i386 m68k mips mips64el mipsel ppc64el riscv64 s390x sh4
+Architecture: amd64 arm64 armel armhf i386 loong64 m68k mips mips64el mipsel ppc64el riscv64 s390x sh4
 Depends: musl-dev (= ${binary:Version}), ${misc:Depends}
 Replaces: musl (<< 1.1.15-1)
 Breaks: musl (<< 1.1.15-1)

=== debian/rules ===
--- 
+++ 
@@ -45,7 +45,7 @@
 CROSS_COMPILE=$(DEB_HOST_GNU_TYPE)-
 export CROSS_COMPILE
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
 
 # Substitute control file variables depending on the debian libc type
 # If musl is the native libc, we can provide libc and depend on linux-libc-dev
@@ -53,7 +53,7 @@
   GENCTRL_OPTIONS = -Vlibc-dev:Provides=libc-dev -Vlinux-libc-dev:Depends=linux-libc-dev
   GCC_WRAPPER = no
 else
-  GENCTRL_OPTIONS = -Vlinux-musl-dev:Recommends=linux-musl-dev -Vgcc:Depends=gcc-$(HOST_GNU_TYPE_PKG)
+  GENCTRL_OPTIONS = -Vgcc:Depends=gcc-$(HOST_GNU_TYPE_PKG)
   GCC_WRAPPER = yes
 endif
 
@@ -73,7 +73,7 @@
 	dh_auto_configure -- --libdir=/usr/lib/$(MUSL_TRIPLE) --includedir=/usr/include/$(MUSL_TRIPLE) --host=$(DEB_HOST_GNU_TYPE) --enable-gcc-wrapper=$(GCC_WRAPPER) --enable-debug
 
 execute_after_dh_auto_install:
-	rm debian/tmp/usr/lib/$(MUSL_TRIPLE)/libcrypt.a
+	rm debian/tmp/usr/include/$(MUSL_TRIPLE)/crypt.h debian/tmp/usr/lib/$(MUSL_TRIPLE)/libcrypt.a
 
 execute_after_dh_install:
 ifeq ($(GCC_WRAPPER),yes)

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" \
 https://musl.libc.org/ releases/musl-@ANY_VERSION@@ARCHIVE_EXT@
